/*--------------------------*/
/* CRC l擾̃Tv     */
/*--------------------------*/
#include <stdio.h>
#include <sys/stat.h>
#include <process.h>
#include "./crc.h"

DWORD GetFileSize(const char *lpszFilePath);

DWORD GetFileSize(const char *lpszFilePath)
{
	struct stat statBuff;

	if (stat(lpszFilePath, &statBuff) != 0)
		return (-1);

	return (statBuff.st_size);
}

int main(int argc, char *argv[])
{
	         CCrc16 Crc16;
			 CCrc32 Crc32;
	         FILE   *in;
	unsigned char   *buffer;
	unsigned long   i;
	         size_t f_Size;

	if (argc != 2)
	{
		puts("t@C CRC l擾Tv Y.Kimizuka 2005/06/04");
		puts("gp@: CRC <CRC l擾t@C>");
		exit(1);
	}

	if (!(in = fopen(argv[1], "rb")))
	{
		puts("t@C̃I[vɎs܂D\n");
		exit(1);
	}

	f_Size = GetFileSize(argv[1]);
	if (!(buffer = new unsigned char [f_Size]))
	{
		puts("̊mۂɎs܂D\n");
		exit(1);
	}

	fread(buffer, 1, f_Size, in);

	fclose(in);

	for (i = 0; i < f_Size; i ++)
		Crc16.Calc(buffer[i]);

	for (i = 0; i < f_Size; i ++)
		Crc32.Calc(buffer[i]);

	printf("16 Bit CRC = %0.4xh\n", Crc16.GetValue());
	printf("32 Bit CRC = %0.8xh\n", Crc32.GetValue());

	delete [] buffer;

	return (0);
}
